#define HARDWARE_GLOBALS

#include "..\User\includes.h"

union REC_BUFF_UNION REC_BUFF[MAX_REC_BUFF];								 
uint8 send_buff[2046];

void SetMacID(uint8 *mac_ptr)   
{
    EthernetMACAddrSet(ETH_BASE, mac_ptr);
}

void EthernetIntHandler(void)
{
    unsigned long ulTemp;
    
    ulTemp = EthernetIntStatus(ETH_BASE, false);
    EthernetIntClear(ETH_BASE, ulTemp);
    if(ulTemp & ETH_INT_RX)
    {
        Rec_Packet();
	   
    }
}
 	
void Send_Packet(struct _pkst *TxdData)
{
    struct _pkst *ExPtr;
    uint16 ii,length=0;
    static uint16 lengthdata=0;
    uint16 jj;
    
    ExPtr=TxdData;
    while(ExPtr->STPTR!=NULL)
    {
        length=length+ExPtr->length;
        ExPtr=ExPtr->STPTR;
    }
    length=length+ExPtr->length;
    ii=length;
    ExPtr=TxdData;
    while(ExPtr->STPTR!=NULL)
    {
        for(jj=0;jj<ExPtr->length;jj++)
        {
            send_buff[lengthdata] =*(((uint8 *)ExPtr->DAPTR)+jj);
            lengthdata++;
        }
        ExPtr=ExPtr->STPTR;
    }
    for(jj=0;jj<ExPtr->length;jj++)
    {
        send_buff[lengthdata] =*(((uint8 *)ExPtr->DAPTR)+jj);
        lengthdata++;
    }
    EthernetPacketPut(ETH_BASE,send_buff,ii);
    lengthdata=0;   
}
 
void Rec_Packet(void) 
{
    static uint8 REC_BUFF_NUM=0;
    uint8 *REC_BUFF_PTR_BYTES;
    uint16 length;

    OSSchedLock();
    do
    {		
        length = EthernetPacketNonBlockingGet(ETH_BASE,REC_BUFF[REC_BUFF_NUM].bytes,1514);
        if( (length > 0) && (length < 0x600) )
        {
            REC_BUFF_PTR_BYTES=REC_BUFF[REC_BUFF_NUM].bytes;
            #ifdef Little_End
                if((((ipethernet*)REC_BUFF_PTR_BYTES)->NextProtocal==0x0008)
                                    ||(((ipethernet*)REC_BUFF_PTR_BYTES)->NextProtocal==0x0608))
            #endif
            #ifdef Big_End
                if((((ipethernet*)REC_BUFF_PTR_BYTES)->NextProtocal==0x0800)
                                    ||(((ipethernet*)REC_BUFF_PTR_BYTES)->NextProtocal==0x0806))
            #endif
	    {
                OSSchedUnlock();
                Rec_Ethernet_Packed(REC_BUFF_PTR_BYTES,0);
                REC_BUFF_NUM++;
                if(REC_BUFF_NUM>=5)
                {
                    REC_BUFF_NUM=0;
                }
                OSSchedLock();					
            }
        }
        else
            break;	
    }while(1);
    OSSchedUnlock();
}

void InitNic(uint8 num)  
{
    uint32  i;
    uint32 ulTemp;

    SysCtlPeripheralReset(SYSCTL_PERIPH_ETH);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_ETH);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF);
    GPIODirModeSet(GPIO_PORTF_BASE, (GPIO_PIN_2 | GPIO_PIN_3), GPIO_DIR_MODE_HW);
    GPIOPadConfigSet(GPIO_PORTF_BASE, (GPIO_PIN_2 | GPIO_PIN_3), GPIO_STRENGTH_2MA, GPIO_PIN_TYPE_STD);
    EthernetIntDisable(ETH_BASE, (ETH_INT_PHY | ETH_INT_MDIO | ETH_INT_RXER | ETH_INT_RXOF | ETH_INT_TX | ETH_INT_TXER | ETH_INT_RX));
    ulTemp = EthernetIntStatus(ETH_BASE, false);
    EthernetIntClear(ETH_BASE, ulTemp);
    EthernetInit(ETH_BASE);
    for(i=0;i<255;i++) ;
    EthernetConfigSet(ETH_BASE, (ETH_CFG_TX_DPLXEN | ETH_CFG_TX_CRCEN | ETH_CFG_TX_PADEN));
    EthernetEnable(ETH_BASE);
    IntEnable(INT_ETH);
    IntPrioritySet(INT_ETH, 0xFF);
    EthernetIntEnable(ETH_BASE, ETH_INT_RX);
    for(i=0;i<255;i++);
    SetMacID(NetPort[num].My_Mac);
    for(i=0;i<3000000;i++) ;    
}



uint16 swap_int16(uint16 temp)
{
    uint16 temp1;

    temp1=(temp&0xff00)>>8;
    temp=(temp&0x00ff)<<8;
    return(temp+temp1);
}

uint32 swap_int32(uint32 temp)
{
    union w temp232, temp132;

    temp232.dwords=temp;
    temp132.bytes.byte0=temp232.bytes.byte3;
    temp132.bytes.byte1=temp232.bytes.byte2;
    temp132.bytes.byte2=temp232.bytes.byte1;
    temp132.bytes.byte3=temp232.bytes.byte0;
    return(temp132.dwords);
}

uint16 Char2ToInt16(uint8 *temp)
{
    uint16 temp16;

    temp16=((uint16)(*temp))<<8;
    temp++;
    temp16=temp16+(uint16)(*temp);
    return(temp16);
}

uint32 Char4ToInt32(uint8 *temp)
{
    uint32 temp32;

    temp32=((uint32)(*temp))<<24;
    temp++;
    temp32=temp32+(((uint32)(*temp))<<16);
    temp++;
    temp32=temp32+(((uint32)(*temp))<<8);
    temp++;
    temp32=temp32+(uint32)(*temp);
    return(temp32);
}  

