#ifdef TCP_GLOBALS
	#define TCP_EXT
#else
	#define TCP_EXT extern 
#endif 

TCP_EXT OS_EVENT *AppSemSend[MAX_TCP_LINKS];
TCP_EXT OS_EVENT *AppSemCon[MAX_TCP_LINKS];
TCP_EXT OS_EVENT *AppSemDisc[MAX_TCP_LINKS];	

#define 	TCP_STATE_CLOSED        0
#define 	TCP_STATE_LISTEN        1
#define 	TCP_STATE_SYN_RCVD      2
#define 	TCP_STATE_SYN_SENT      3
#define 	TCP_STATE_ESTABLISHED   4
#define 	TCP_STATE_FIN_WAIT1     5
#define 	TCP_STATE_FIN_WAIT2     6
#define 	TCP_STATE_CLOSING       7
#define 	TCP_STATE_CLOSE_WAIT    8
#define 	TCP_STATE_LAST_ACK      9
#define 	TCP_STATE_TIME_WAIT     10

#define 	TCP_FIN 0x01
#define 	TCP_SYN 0x02
#define 	TCP_RST 0x04
#define 	TCP_PSH 0x08
#define 	TCP_ACK 0x10
#define 	TCP_URG 0x20

struct tcp_data
{  
	uint16 SourcePort;
	uint16 DestPort;
	uint32 SeqNum;
	uint32 AckNum;
	uint8 offset;
	uint8 control;
	uint16 window;
	uint16 Crc;
	uint16 urg;
	uint8 tcpdata[MAX_TCP_DATA];
};

struct tcp_dhead
{
	uint8 rev; 
	uint8 NextProtocal;
	uint16 TotalLen;
	uint8 SourceIp[4];
	uint8 DestId[4];
};

typedef struct
{
	struct tcp_dhead TcpDHead;
	struct tcp_data Tcp;
}tcp_send;

struct Socket_Type
{
	uint16 My_Port;
	uint16 Dest_Port;
	uint8 Dest_Ip[4];
	uint8 My_Ip[4];
	uint32 IRS;
	uint32 ISS;
	uint32 Rcv_Next;
	uint32 Send_Next;
	uint32 Sent_UnAck;
	uint32 RecPassSeq;
	uint32 RecPassAck;
	uint32 SenPassSeq;
	uint32 SenPassAck;
	uint32 RecFutureAck;
	uint32 SenFutureSeq;
	uint16 Rcv_Window;
	uint16 Snd_Window;
	uint16 Dest_Max_Seg_Size;
	uint16 My_Max_Seg_Size;
	uint32 My_Wl1;
	uint32 My_Wl2;
	uint8 State;
	uint8 Open;
	uint8 ResendState;
	uint8 ResendTime;
	uint16 ResendLength;
	uint8 StaSem;
	uint8 TcpDHeadUint8[12];
	uint8 TcpHeadUint8[MAX_TCP_DATA+20];
	uint8 TcpDataQ[MAX_TCP_DATA];
	uint16 TcpDataQWrPtr;
	uint16 TcpDataQRdPtr;
};

TCP_EXT uint16 CheckSumTcp1(uint8 num, uint16 length);
TCP_EXT void Delete_Socket(uint8 num) ;
TCP_EXT struct Socket_Type TcpStatus[MAX_TCP_LINKS];
TCP_EXT void TcpHeadHandle(uint8 num, uint16 Tcp_headlength_Control);
TCP_EXT uint8 Process_Tcp1(Rec_Ptr *Tcp_Rec);
TCP_EXT void Tcp_Initial(void);

