#include "..\User\includes.h"

/********************************************************************************************
    USER TASK PRIORITIES
********************************************************************************************/
#define TASK_START_PRIO     0
#define TASK_LED_PRIO       15
#define TASK_OLED_PRIO      6
#define TASK_HTTP_PRIO      7

/********************************************************************************************
    USER TASK STACK SIZES
********************************************************************************************/
#define TASK_Startup_STACK    500
#define TASK_LED_STACK        500
#define TASK_OLED_STACK       500
#define TASK_HTTP_STACK       500

/********************************************************************************************
    USER TASK STACK
********************************************************************************************/
OS_STK TASK_Startup_stack[TASK_Startup_STACK];
OS_STK TASK_LED_stack[TASK_LED_STACK];
OS_STK TASK_OLED_stack[TASK_OLED_STACK];
OS_STK TASK_HTTP_stack[TASK_HTTP_STACK];

/********************************************************************************************
    USER TASK
********************************************************************************************/
/********************************************************************************************
    HTTP^XN
********************************************************************************************/
void Task_HTTP(void *pdata)
{
    // HTTPX|X`
    unsigned char Response_Header[] = 
    {
        "HTTP/1.0 200 OK\r\n"
        "Connection: close\r\n"
        "Content-Type: text/html\r\n"
        "\r\n"
    };
    
    // \weby[Whtml\[X
    unsigned char page[] =
    {
        "<html>\r\n"
        "<head>\r\n"
        "</head>\r\n"
        "<body>\r\n"
        "HELLO WORLD\r\n"
        "</body>\r\n"
        "</html>\r\n"
    };
    
    unsigned char Connection = 0;       // uEUƂ̐ڑ
    unsigned char Receive_data[400];    // Mobt@
    int addrlen;                        // NCAg̃AhX
    SOCKET srcSocket;                   // \Pbg
    struct sockaddr servaddr, cliaddr;  // \PbgAhX\
    
    // T[o(}CR)IPAhXу|[gԍ̐ݒ
    servaddr.sin_family = 0;
    servaddr.sin_addr[0] = NetPort[0].My_Ip[0];
    servaddr.sin_addr[1] = NetPort[0].My_Ip[1];
    servaddr.sin_addr[2] = NetPort[0].My_Ip[2];
    servaddr.sin_addr[3] = NetPort[0].My_Ip[3];
    servaddr.sin_port = 80;
    
    // \Pbg̐
    srcSocket = *socket(PF_INET, SOCK_STREAM, TCP_PROTOCOL);
    
    // \Pbg̃oCh
    bind((SOCKET *)&srcSocket, (struct sockaddr*)&servaddr, sizeof(servaddr));
    
    // ڑ̋
    listen((SOCKET *)&srcSocket, 4);

    while (1)
    {
        // ڑt
        Connection = accept((SOCKET *)&srcSocket, (struct sockaddr *)&cliaddr, &addrlen);
        if (Connection != 0xff)
        {
            OSTimeDly(20);
            // pPbgM
            recv(Connection, Receive_data, sizeof(Receive_data), 0);
            // HTTPNGXg̃`FbN
            if (Receive_data[5] == ' ')
            {
                // HTTPX|X𑗐M
                send(Connection, Response_Header, sizeof(Response_Header) - 1, 0);
                // html\[X𑗐M
                send(Connection, page, sizeof(page), 0 );
            }
            // Mf[^NA
            memset(Receive_data, 0, 400);
            OSTimeDly(20);
            // ڑI
            close(Connection);
        }
    }
}

/********************************************************************************************
    OLED\^XN
********************************************************************************************/
void Task_OLED(void *pdata)
{
    int i, j;               // ėpJE^
    int IP[4] = MY_IP_1ID;  // IPAhX
    char IP_Address[17];    // IPAhX\pz
    
    // IPAhX𕶎ɕϊ
    j = 0;
    for (i=0;i<4;i++)
    {
        IP_Address[j++] = (IP[i] / 100) + 0x30;
        IP_Address[j++] = (IP[i] % 100 / 10) + 0x30;
        IP_Address[j++] = (IP[i] % 100 % 10) + 0x30;
        IP_Address[j++] = '.';
    }
    IP_Address[16] = '\0';
    
    // OLED̏
    RIT128x96x4Init(1000000);
    
    // OLEDɕIPAhX\
    RIT128x96x4StringDraw("HTTP SERVER", 31, 0, 15);
    RIT128x96x4StringDraw("IP ADDRESS:", 0, 16, 10);
    RIT128x96x4StringDraw(IP_Address, 32, 24, 15);

    while (1)
    {
        // ԑ҂
        OSTimeDly(OS_TICKS_PER_SEC / 100);
    }
}

/********************************************************************************************
    LED_Ń^XN
********************************************************************************************/
void Task_LED(void *pdata)
{
    // LED1̃ytFݒ
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF);
    GPIOPinTypeGPIOOutput(GPIO_PORTF_BASE, GPIO_PIN_0);

    while (1)
    {
        // StatusLED1bœ_
        GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_0, GPIO_PIN_0);
        OSTimeDly(OS_TICKS_PER_SEC / 2);
        GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_0, 0);
        OSTimeDly(OS_TICKS_PER_SEC / 2);
    }
}

/********************************************************************************************
    X^[gAbv^XN
********************************************************************************************/
void Task_Startup (void  *pdata)
{ 
    // ^[Qbg
    targetInit();
    
    // [U[^XN쐬
    OSTaskCreate(Task_LED, (void *)0, &TASK_LED_stack[TASK_LED_STACK - 1], TASK_LED_PRIO);
    OSTaskCreate(Task_OLED, (void *)0, &TASK_OLED_stack[TASK_OLED_STACK - 1], TASK_OLED_PRIO);
    OSTaskCreate(Task_HTTP, (void *)0, &TASK_HTTP_stack[TASK_HTTP_STACK - 1], TASK_HTTP_PRIO);

    while (1)
    {
        // ԑ҂
        OSTimeDly(OS_TICKS_PER_SEC / 100);
    }
}

/********************************************************************************************
    C
********************************************************************************************/
void main (void)
{
    // OS
    OSInit();
    
    // X^[gAbv^XN쐬
    OSTaskCreate(Task_Startup, (void *)0, &TASK_Startup_stack[TASK_Startup_STACK - 1], TASK_START_PRIO);

    // OSX^[g
    OSStart();
}

/********************************************************************************************
    END FILE 
********************************************************************************************/
